	BITS 16
	ORG 7C00h

start:

	cli			; both for when this is in pmode
				; and to ensure we get the input

	mov ah,0Eh		; "prompt"

	mov al,'T'
	int 10h
	mov al,'B'
	int 10h
	mov al,'O'
	int 10h
	mov al,'S'
	int 10h
	mov al,' '
	int 10h
	mov al,'0'
	int 10h
	mov al,'.'
	int 10h
	mov al,'2'
	int 10h
	mov al,'.'
	int 10h
	mov al,'0'
	int 10h
	mov al,0Dh
	int 10h
	mov al,0Ah
	int 10h


read_kbd:
	in al,64h		; read status byte
	and al,01h		; wait for OBF==1
	jz read_kbd

	in al,60h		; read scancode byte

	cmp al,10h
	je near .q
	cmp al,11h
	je near .w
	cmp al,12h
	je near .e
	cmp al,13h
	je near .r
	cmp al,14h
	je near .t
	cmp al,15h
	je near .y
	cmp al,16h
	je near .u
	cmp al,17h
	je near .i
	cmp al,18h
	je near .o
	cmp al,19h
	je near .p

	cmp al,1Eh
	je near .a
	cmp al,1Fh
	je near .s
	cmp al,20h
	je near .d
	cmp al,21h
	je near .f
	cmp al,22h
	je near .g
	cmp al,23h
	je near .h
	cmp al,24h
	je near .j
	cmp al,25h
	je near .k
	cmp al,26h
	je near .l

	cmp al,2Ch
	je near .z
	cmp al,2Dh
	je near .x
	cmp al,2Eh
	je near .c
	cmp al,2Fh
	je near .v
	cmp al,30h
	je near .b
	cmp al,31h
	je near .n
	cmp al,32h
	je near .m

	cmp al,0Eh
	je near .backspace

	cmp al,39h
	je near .space

	cmp al,1Ch
	je near .enter

	jmp read_kbd

.q:
	mov ah,0Eh
	mov al,'Q'
	int 10h
	jmp read_kbd

.w:
	mov ah,0Eh
	mov al,'W'
	int 10h
	jmp read_kbd

.e:
	mov ah,0Eh
	mov al,'E'
	int 10h
	jmp read_kbd

.r:
	mov ah,0Eh
	mov al,'R'
	int 10h
	jmp read_kbd

.t:
	mov ah,0Eh
	mov al,'T'
	int 10h
	jmp read_kbd

.y:
	mov ah,0Eh
	mov al,'Y'
	int 10h
	jmp read_kbd

.u:
	mov ah,0Eh
	mov al,'U'
	int 10h
	jmp read_kbd

.i:
	mov ah,0Eh
	mov al,'I'
	int 10h
	jmp read_kbd

.o:
	mov ah,0Eh
	mov al,'O'
	int 10h
	jmp read_kbd

.p:
	mov ah,0Eh
	mov al,'P'
	int 10h
	jmp read_kbd

.a:
	mov ah,0Eh
	mov al,'A'
	int 10h
	jmp read_kbd

.s:
	mov ah,0Eh
	mov al,'S'
	int 10h
	jmp read_kbd

.d:
	mov ah,0Eh
	mov al,'D'
	int 10h
	jmp read_kbd

.f:
	mov ah,0Eh
	mov al,'F'
	int 10h
	jmp read_kbd

.g:
	mov ah,0Eh
	mov al,'G'
	int 10h
	jmp read_kbd

.h:
	mov ah,0Eh
	mov al,'H'
	int 10h
	jmp read_kbd

.j:
	mov ah,0Eh
	mov al,'J'
	int 10h
	jmp read_kbd

.k:
	mov ah,0Eh
	mov al,'K'
	int 10h
	jmp read_kbd

.l:
	mov ah,0Eh
	mov al,'L'
	int 10h
	jmp read_kbd

.z:
	mov ah,0Eh
	mov al,'Z'
	int 10h
	jmp read_kbd

.x:
	mov ah,0Eh
	mov al,'X'
	int 10h
	jmp read_kbd

.c:
	mov ah,0Eh
	mov al,'C'
	int 10h
	jmp read_kbd

.v:
	mov ah,0Eh
	mov al,'V'
	int 10h
	jmp read_kbd

.b:
	mov ah,0Eh
	mov al,'B'
	int 10h
	jmp read_kbd

.n:
	mov ah,0Eh
	mov al,'N'
	int 10h
	jmp read_kbd

.m:
	mov ah,0Eh
	mov al,'M'
	int 10h
	jmp read_kbd

.space:
	mov ah,0Eh
	mov al,' '
	int 10h
	jmp read_kbd

.enter:
	mov ah,0Eh

	mov al,0Dh
	int 10h
	mov al,0Ah
	int 10h
	jmp read_kbd



.backspace:			; this is a fun little thing that will
				; need to be reworked in pmode.
	mov ah,0Eh

	mov al,08h
	int 10h
	mov al,20h
	int 10h
	mov al,08h
	int 10h
	
	jmp read_kbd

	times 510-($-$$) db 0
	dw 0xAA55